unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, OleCtrls, CortonaVRMLClientLibrary_TLB, StdCtrls,
  FileCtrl, inifiles, Menus, ComCtrls, Buttons, ImgList, ToolWin,ShellAPI,
  ActnList,Strutils;

type
  tform1 = class(twincontrol)
    Cortona1: TCortona;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    Panel4: TPanel;
    ToolButton1: TCheckbox;
    ToolButton2: TCheckbox;
    ToolButton3: TCheckbox;
    ToolButton4: TCheckbox;
    ToolButton5: TSpeedButton;
    ToolButton6: TCheckbox;
    Timer1: TTimer;
    procedure Cortona1FrameRateMeasured(ASender: TObject; fps: Single);
    procedure Cortona1SceneLoaded(ASender: TObject; Success: WordBool);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
    procedure nacti_scenu(a:string);
    procedure vytvorprvky(aOwner: HWND);
  private

  public
    { Public declarations }
  end;

var
  dir,cesta:string;
  fps_soucet,fps_soucet_10:single;
  fps_pole:array [1..10] of single;
  fps_pocet:integer;
  cas:ttime;
  ImageList1: TImageList;


implementation


{$R obrazky.res}

procedure tform1.nacti_scenu(a:string);
begin
    a:=ansireplacestr(a,'file://','');
    cortona1.Scene:=a;
end;

procedure TForm1.vytvorprvky(aOwner: HWND);
var s:tstatuspanel;
begin
    Self.ParentWindow:=aowner;

    Align:=alclient;

    StatusBar1:=TStatusBar.Create(self);
    StatusBar1.ParentWindow:=self.Handle;
    StatusBar1.Parent:=self;
    s:=StatusBar1.Panels.Add; s.Width:=100;
    s:=StatusBar1.Panels.Add; s.Width:=110;
    s:=StatusBar1.Panels.Add; s.Width:=150;
    s:=StatusBar1.Panels.Add; s.Width:=200;

    Panel3:=TPanel.Create(self);
    Panel3.Align:= alClient;
    panel3.Parent:=self;
    BevelOuter:= bvNone;

    cortona1:=tcortona.Create(self);
    cortona1.Parent:=Panel3;
    cortona1.ParentColor := False;
    cortona1.Align := alClient;
    cortona1.OnSceneLoaded := Cortona1SceneLoaded;
    cortona1.OnFrameRateMeasured := Cortona1FrameRateMeasured ;
    cortona1.NavigationMode:=3;
    cesta:=extractfilepath(application.ExeName);

    Panel4:=TPanel.Create(self);
    panel4.Parent:=panel3;
    Panel4.Height:=28;
    Panel4.Align:= alBottom;
    panel4.BevelOuter:= bvLowered;
    panel4.Color:=clred;

    ToolButton1:=TCheckbox.Create(self);
    ToolButton1.Parent:=panel4;
    ToolButton1.Left:=8;
    ToolButton1.Top := 2;
    ToolButton1.Width := 50;
    ToolButton1.height := 24;
    //Toolbutton1.Glyph.LoadFromResourceName(hinstance,'PAUZA');
    ToolButton1.Caption := 'Pauza';
    ToolButton1.ParentShowHint := False;
    ToolButton1.ShowHint := True;
    ToolButton1.OnClick := ToolButton1Click;

    ToolButton5:=TSpeedButton.Create(self);
    ToolButton5.Parent:=panel4;
    ToolButton5.Left:=66;
    ToolButton5.Top := 2;
    ToolButton5.Width := 24;
    ToolButton5.height := 24;
    ToolButton5.OnClick := Action1Execute;
    Toolbutton5.Glyph.LoadFromResourceName(hinstance,'RELOAD');
    ToolButton5.ParentShowHint := False;
    ToolButton5.ShowHint := True;
    ToolButton5.hint := 'Obnov scnu';

    ToolButton2:=TCheckbox.Create(self);
    ToolButton2.Parent:=panel4;
    ToolButton2.Left:=100;
    ToolButton2.Top := 2;
    ToolButton2.Width := 140;
    ToolButton2.height := 24;
    ToolButton2.OnClick := ToolButton2Click;
    //Toolbutton2.Glyph.LoadFromResourceName(hinstance,'ANTIALIASING');
    ToolButton2.ParentShowHint := False;
    ToolButton2.ShowHint := True;
    ToolButton2.Caption := 'Antialiasing';
    //ToolButton2.Style := tbsCheck;

    ToolButton6:=TCheckbox.Create(self);
    ToolButton6.Parent:=panel4;
    ToolButton6.Left:=180;
    ToolButton6.Top := 2;
    ToolButton6.Width := 100;
    ToolButton6.height := 24;
    ToolButton6.OnClick := ToolButton6Click;
    //Toolbutton6.Glyph.LoadFromResourceName(hinstance,'WIRE');
    ToolButton6.ParentShowHint := False;
    ToolButton6.ShowHint := True;
    ToolButton6.Caption := 'Drtov model';
    //ToolButton6.Style := tbsCheck;

    timer1:=ttimer.Create(self);
    timer1.Interval:=100;
    timer1.ontimer:=Timer1Timer;
end;

procedure TForm1.Cortona1FrameRateMeasured(ASender: TObject; fps: Single);
begin
    statusbar1.Panels[0].Text:=format('Te je %.2f fps',[fps]);

    fps_soucet:=fps_soucet+fps;
    inc(fps_pocet);
    statusbar1.Panels[1].Text:=format('Prmr je %.2f fps',[fps_soucet/fps_pocet]);

    fps_soucet_10:=fps_soucet_10 - fps_pole[(fps_pocet mod 10)+1] + fps;
    fps_pole[(fps_pocet mod 10)+1]:=fps;
    statusbar1.Panels[2].Text:=format('Prmr za 10s je %.2f fps',[fps_soucet_10/10]);
end;

procedure TForm1.Cortona1SceneLoaded(ASender: TObject; Success: WordBool);
var i:integer;
begin
    fps_soucet:=0;
    fps_pocet:=0;
    for i:=1 to 10 do fps_pole[i]:=0;
    Caption:='VRMLbrowser - '+ansireplacestr(cortona1.Scene,'file://','');
    cas:=time();
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
    cortona1.Freeze:=toolbutton1.checked;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin

    if (cortona1.RendererHints and 512) > 0 then cortona1.RendererHints:=cortona1.RendererHints-512 else
    cortona1.RendererHints:=cortona1.RendererHints+512;
    if (cortona1.RendererHints and 32768) > 0 then cortona1.RendererHints:=cortona1.RendererHints-32768 else
    cortona1.RendererHints:=cortona1.RendererHints+32768;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
     if (cortona1.RendererHints and 256) > 0 then cortona1.RendererHints:=cortona1.RendererHints-256 else
    cortona1.RendererHints:=cortona1.RendererHints+256;
end;

procedure TForm1.Action1Execute(Sender: TObject);
begin
    toolbutton1.checked:=false;
    ToolButton1Click(nil);
    nacti_scenu(cortona1.Scene);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var hodina,minuta,sekunda,msekunda:word;
begin
    decodetime(time()-cas,hodina,minuta,sekunda,msekunda);
    statusbar1.Panels[3].Text:=format('as je %.2d:%.2d:%.2d.%.3d',[hodina,minuta,sekunda,msekunda]);
end;

procedure TForm1.Action2Execute(Sender: TObject);
begin
    showmessage(inttostr(cortona1.RendererHints));
end;

end.
